#pragma once
#include "xast_parse.h"
#include <QHash>

namespace compare {
	enum class Type {
		UpstreamAlter,
		FragmentAlter
	};

	class Compare {
	private:
		QHash<QString, std::shared_ptr<xast_parse::StoryDefine>> _graph_base;

	public:
		explicit Compare(const QHash<QString, std::shared_ptr<xast_parse::StoryDefine>>& graph);

		const QHash<QString, std::shared_ptr<xast_parse::StoryDefine>> &graphBind() const;

		QList<std::shared_ptr<xast_parse::FragmentDefine>> changeCompare(Type type,
		const QHash<QString, std::shared_ptr<xast_parse::StoryDefine>>& g_old) const;

	private:
		/*
		* @brief ݱȽ
		* @param a 
		* @param b 
		* @return true-б
		*/
		bool fragment_check(std::shared_ptr<xast_parse::FragmentDefine> a, std::shared_ptr<xast_parse::FragmentDefine> b) const;
		/*
		* @brief ݱȽ
		* @param a 
		* @param b 
		* @return true-б
		*/
		bool upstream_check(std::shared_ptr<xast_parse::IElementSlice> a, std::shared_ptr<xast_parse::IElementSlice> b) const;
	};

}

