#pragma once

#include <memory>
#include <QList>
#include <libtoken.h>
#include "libsyntax.h"

namespace ast_basic {
    // ﷨ ================================================================================================
    /**
     * @brief ﷨Ͻڵ/ʽڵ
     */
    class IExprInst {
    public:
        virtual ~IExprInst() = default;

        /**
         * @brief ȡʽĽ
         * @return
         */
        virtual std::shared_ptr<const lib_syntax::ExprRule> definedRule() const = 0;
        //=====================================================
        /**
         * ȡ﷨ڵԴļ·.
         * 
         * \return ļ·
         */
        virtual QString filePath() const = 0;
        /**
         * ȡ﷨ڵtoken.
         * 
         * \return token
         */
        virtual QList<std::shared_ptr<const lib_token::IToken>> tokens() const = 0;
        /**
         * Уʽڲtokenʵ.
         * 
         * \param token_inst ʵ
         */
        virtual void addToken(std::shared_ptr<const lib_token::IToken> token_inst) = 0;
        //=====================================================
        /**
         * @brief ӱʽ
         * @return
         */
        virtual QList<std::shared_ptr<const IExprInst>> children() const = 0;
        /**
         * @brief ӱʽ.
         * 
         * \param inst ӱʽʵ
         */
        virtual void addChild(std::shared_ptr<const IExprInst> inst) = 0;
    };


    // ﷨ ==========================================================================================
    /**
     * @brief ʽڵ
     */
    class LIBSYNTAX_EXPORT ExprElement : public ast_basic::IExprInst, public std::enable_shared_from_this<ExprElement> {
    private:
        std::shared_ptr<const lib_syntax::ExprRule> _expr_rule;
        QList<std::shared_ptr<const IExprInst>> children_store;
        QList<std::shared_ptr<const lib_token::IToken>> tokens_bind;

    public:
        ExprElement(std::shared_ptr<const lib_syntax::ExprRule> bind);

        // ͨ Expression ̳
        std::shared_ptr<const lib_syntax::ExprRule> definedRule() const override;
        QString filePath() const override;

        QList<std::shared_ptr<const lib_token::IToken>> tokens() const override;
        void addToken(std::shared_ptr<const lib_token::IToken> token_inst) override;

        QList<std::shared_ptr<const IExprInst>> children() const override;
        void addChild(std::shared_ptr<const IExprInst> inst) override;
    };

    class LIBSYNTAX_EXPORT ExprsContext : public lib_syntax::IContext, public std::enable_shared_from_this<ExprsContext> {
    private:
        QList<std::shared_ptr<const lib_syntax::IBasicRule>> rule_stack;
        QList<std::shared_ptr<IExprInst>> expression_stack;
        QList<std::shared_ptr<const ast_basic::IExprInst>> document_store;
        QString current_file_path;
        QList<std::tuple<QString, int, QString>> errors_storage;

    public:
        ExprsContext();

        // ͨ IContext ̳
        virtual void setCurrentFile(const QString& path);
        virtual QString currentFile() const;

        std::shared_ptr<ast_basic::IExprInst> currentExprInst() const override;
        void pushExprInst(std::shared_ptr<ast_basic::IExprInst> current_inst) override;
        std::shared_ptr<ast_basic::IExprInst> popExprInst() override;

        std::shared_ptr<const lib_syntax::IBasicRule> currentExprRule() const override;
        void pushExprRule(std::shared_ptr<const lib_syntax::IBasicRule> inst) override;
        std::shared_ptr<const lib_syntax::IBasicRule> popExprRule() override;
        virtual QList<std::shared_ptr<const lib_syntax::IBasicRule>> currentExprRuleStack() const;

        virtual void appendDocInst(std::shared_ptr<ast_basic::IExprInst> inst) override;
        virtual QList<std::shared_ptr<const ast_basic::IExprInst>> getDocInsts() const override;

        void appendParseErrors(const QString& file_path, int start, const QString& error_msg) override;
        QStringList errors() const override;
        void clearErrors(const QString& file_path, int start) override;
    };
}